#!/usr/bin/perl -T
# $Id: main.cgi,v 1.20 2017/09/01 07:52:13 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################
use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use RFC::Furnace;
use SocketClient;
use CGI qw(:standard :netscape);
use Sys::Hostname;

my $hostname = hostname;
my $pwdhost = get_cv('passwds','passwd_server');
my $name = &get_cv('global','server_name');
$name = hostname unless ($name);

my $isadmin = 0;
if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end('../RFCfurnace/manual.pdf');
}
else
{
    my $uid = login_ok();
    $isadmin = &is_admin();
    if ($uid)
    { 
	$uid = &RFC::Main::passwd_client('pwdstatus',&get_id());
        &print_header($name);
	print '<script src="/celltest/RFCcontrol.js"></script>',"\n";
        print '<link rel="stylesheet" type="text/css" href="/RFCfurnace/Furnace.css" />',"\n";
	top_nav_bar_start();
	if ($isadmin)
	{
	    top_nav_bar_button('../celltest/confmanage.cgi','','','Global configuration','s0');
	    top_nav_bar_button('../celltest/usermanage.cgi','','','User management','s1');
	}
	else
	{
	    if ($hostname eq $pwdhost)
	    {
		top_nav_bar_button('task.cgi','','','Manage safty clearances','s3');
	    }
	    else
	    {
		top_no_button;
	    }
	    top_no_button;
	}
	top_no_button();
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	top_no_button();
	&top_nav_bar_button('../celltest/changepwd.cgi','','','Change password','s7');
	&top_nav_bar_button('../celltest/about.cgi','','','About','s8');
	## Specproc for derect access to labysstem, remoove if no labsystem ####
	## top_no_button();
	my $server = get_cv('passwds','passwd_server');
	if (param('action'))
	{
	    &top_nav_bar_button('main.cgi','','','To furnace groups','s6');
	}
	else
	{
	    if (CGI::https())
	    {
		&top_nav_bar_button('https://'.$server.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	    }
	    else
	    {
		&top_nav_bar_button('http://'.$server.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	    }
	}
	## End specproc
	&end_top_bar;
        if ($uid =~ /RESET/)
        {
            print center(h2({-class=>'Alert'},"You must change your password!"));
        }
	elsif ($uid =~ /EXPIRE/)
	{
	    print center(h2({-class=>'Alert'},"Your password has expired, Please change password"));
	}
        else
        {
	    if (param('action') && param('action') eq 'select_server')
	    {
		&select_server;
	    }
	    else
	    {
		&main_page;
	    }
	}
	&print_end('../RFCfurnace/manual.pdf');
    }
    else 
    {
	&not_auth;
    }
}
    
exit;


sub select_server
{
    my @list = ();
    my $str = get_cv('celltest','rigs');
    $str = '' unless defined($str);
    my @l = split(/\s*\,\s*/,$str);
    print '<center>';
    print '<table class="main_select">';
    print '<tr><td class="heading" colspan='.scalar(@l).'>';
    print "<center>Select furnace:</center>";
    print '</td></tr><tr>';
    foreach my $r (sort {$a <=> $b} @l)
    {
	push @list,$r;
	my $temp = &get_atemp($r);
	print '<td>';
	print start_form(-action=>'/cgi-bin/RFCfurnace/furnace.cgi');
	&print_hidden();
	print hidden(-name=>'rig',-value=>$r,-force=>1);
	print "<button type=submit class=main4 id=$r> Furnace $r ($temp) </button>";
	print end_form();
	print '</td>';
    }
    print '</table>';
    print '<table class="main_select">';
    print '<tr><td colspan='.scalar(@l).' class="heading">';
    print "<center>Data on all furnace runs</center>";
    print '</td></tr>';
    foreach my $r (sort {$a <=> $b} (@l))
    {
	next unless ($r && $r =~ /\d/);
	print '<td>';
	print start_form(-action=>'/cgi-bin/RFCfurnace/search.cgi');
	&print_hidden();
	print hidden(-name=>'rig',-value=>$r,-force=>1);
	print submit(-name=>'dummy',-value=>'Furnace '.$r,-class=>'main0');
	print end_form();
	print '</td>';
    }
    print '</table>';
    print '</center>';
    &print_js(@list) if (@list);
}

sub main_page
{
    my @riglist = ();
    print '<center>';
    my $server = `/bin/hostname`;
    $server =~ /([\w\-]+)/;
    $server = $1;
    my @list = ();
    my @listservers = ();
    my $listserver = get_cv('servers','listserver');
    if ($listserver)
    {
        chomp $listserver;
        my $str= &RFC::Main::report_client($listserver,'servers');
        my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
        foreach (@l)
        {
            if (/([\w\.\-]+)/)
            {
                push @list,$1;
            }
        }
        $str= &RFC::Main::report_client($listserver,'list_servers');
        @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
        foreach (@l)
        {
            if (/([\w\.\-]+)/)
            {
                push @listservers,$1;
            }
        }
    }
    if (@listservers && @listservers > 1)
    {
	print h2("Avaliable listservers");
	print '<table class="main_select"><tr>';
	foreach my $s (sort @listservers)
	{
	    print '<td>';
	    if (CGI::https())
	    {
		print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    else
	    {
		print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    my $ss = 'http://'.$s;
	    $ss = 'https://'.$s if (CGI::https());
	    &print_hidden();
	    print submit(-name=>'dummy',-value=>$s,-class=>'main1',-id=>'list_'.$s);
	    print end_form();
	    print '</td>';
		print <<END;
<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('list_'+'$s').value = res});
</script>
END

	}
	print '</tr></table>';
    }
    if (@list)
    {
	print p('&nbsp;');
	print h2("Select furnace group");
	print '<table class="main_select">',"\n";
	foreach my $s (sort @list)
	{
	    print '<tr>';
	    my $str = &RFC::Main::report_client($s,'active_rigs');
	    my $ss = 'http://'.$s;
	    $ss = 'https://'.$s if (CGI::https());
	    my @l = ();
	    @l = split(/\t/,$str) if ($str);
	    print '<td>';
	    if (CGI::https())
	    {
		print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    else
	    {
		print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    &action('select_server');
	    &print_hidden();
	    print submit(-name=>'dummy',-value=>$s,-class=>'main2',-id=>$s);
	    print end_form();
	    print '</td>';
	    print <<END;

<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('$s').value = res});
</script>
END

	    if (@l && $l[0] =~ /error/i)
	    {
		print "<th colspan=12>Error: Could not contact server '$s'</th>";
		&errorlog($l[0]);
		next;
	    }
	    print '</tr>',"\n";
	}
    }
    else
    {
        print h2({-class=>'Alert'},"Error: Could not get server list from from '$listserver', using local list only");
        print '<table class="main_select">';
        print '<tr><td colspan=10 class="heading">';
        print "Select furnace:";
        print '</td></tr><tr>';
        my $str = get_cv('celltest','rigs');
        $str = '' unless defined($str);
        my @l = split(/\s*\,\s*/,$str);
        foreach my $r (sort {$a <=> $b} @l)
        {
	    push @riglist,$r;
	    print '<td>';
	    print start_form(-action=>'furnace.cgi');
	    &print_hidden();
	    print hidden(-name=>'rig',-value=>$r,-force=>1);
	    print submit(-name=>'dummy',-value=>'Furnace '.$r,-class=>'main4',-id=>$r);
	    print end_form();
	    print '</td>';
        }
    }
    print '</table>';
    print '</center>';
    &print_js(@riglist) if (@riglist);
}



sub print_js(@)
{
    my @fnlist = ();
    foreach my $x (@_)
    {
	push @fnlist,"   run_ajax('ajax_furnace.cgi','&action=status&furnace=$x',function(res){set_status($x,res)});";
    }
    my $str = join("\n",@fnlist);
    print <<END;

<script>

function check_all()
{
$str   
    setTimeout(check_all,5000);
}

function set_status(id,status)
{
    var e = document.getElementById(id);
    var val = e.innerHTML;
    var reg = /<br>/;
    if (reg.test(val))
    {
	var info = val.split('<br>');
	e.innerHTML = info[0] + '<br>'+status;
    }
    else
    {
	e.innerHTML = e.innerHTML + '<br>'+status;
    }
    if (status == 'Running')
    {	
	e.className = 'main6';
    }
    else if(status == 'Free')
    {
	e.className = 'main4';
    }
    else
    {
	e.className = 'main0';
    }
}

check_all();
</script>
END
}



sub get_atemp($)
{
    my $r = shift;
    my $temp = ' - ';
    eval {
	my $rig = RFC::Rig->new($r);
	my $furnace = RFC::Furnace->new($rig);
	$temp = sprintf("%.0f",$furnace->get_atemp()).' C';
    };
    return $temp;
}
