#!/usr/bin/perl -T
#$Id: pick_elements.cgi,v 1.9 2017/08/31 12:29:32 sqko Exp $
use strict;
use warnings;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use RFC::Furnace;
use CGI qw(:standard :netscape);
my $elements = param('elements');
my $furnace = param('furnace');
print_header('Periodic table of Elements');
print '<link rel="stylesheet" type="text/css" href="/RFCfurnace/PTE.css" />',"\n";

my @list = RFC::Furnace::get_element_data();
shift @list; ## Remove 'element' 0;
foreach my $n (split(/[\s\,]+/,$elements))
{
    foreach my $e (@list)
    {
	next unless ($$e{'short'} eq $n);
	$$e{'test'} = 1;
    }
}
my $modify = 1;
$modify = 0 if (param('readonly'));
my $back = 0;
$back = 1 if (param('back'));
print '<center><table class=status border=0 cellspacing=10 cellpadding=10>';
my $period = 0;
my $group = 0;
foreach (@list)
{
    next unless ($$_{'egroup'} < 20);
    if ($$_{'period'} != $period)
    {
	print '</tr><tr>';
	$period = $$_{'period'};
	$group = 0;
    }
    $group++;
    while ($group < $$_{'egroup'})
    {
	$group++;
	print '<td></td>';
    }
    if ($$_{'test'})
    {
	print '<td class="selected" id="fld_'.$$_{'Z'}.'">';
    }
    else
    {
	print '<td class="'.$$_{'eclass'}.'" id="fld_'.$$_{'Z'}.'">';
    }
    print button(-id=>'btn_'.$$_{'Z'},-name=>$$_{'short'},-label=>$$_{'short'},-class=>$$_{'eclass'},-onclick=>"javascript:alert('$$_{'name'}, Atomic number: $$_{'Z'}\\n$$_{'eclass'}\\n$$_{'comments'}')");
    print '<br>';
    if ($modify)
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-onchange=>"set_element($$_{'Z'})");
	
    }
    else
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-disabled=>1);
    }
    print '</td>';
    print "\n";
}
$period = 0;
$group = 0;
print '</tr><tr><td></td>';
foreach (@list)
{
    next unless ($$_{'egroup'} > 20);
    $$_{'egroup'} -= 20;
    if ($$_{'period'} != $period)
    {
	print '</tr><tr>';
	$period = $$_{'period'};
	$group = 0;
    }
    $group++;
    while ($group < $$_{'egroup'})
    {
	$group++;
	print '<td></td>';
    }
    if ($$_{'test'})
    {
	print '<td class="selected" id="fld_'.$$_{'Z'}.'">';
    }
    else
    {
	print '<td class="'.$$_{'eclass'}.'" id="fld_'.$$_{'Z'}.'">';
    }
    print button(-id=>'btn_'.$$_{'Z'},-name=>$$_{'short'},-label=>$$_{'short'},-class=>$$_{'eclass'},-onclick=>"javascript:alert('$$_{'name'}, Atomic number: $$_{'Z'}\\n$$_{'eclass'}\\n$$_{'comments'}')");
    print '<br>';
    if ($modify)
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-onchange=>"set_element($$_{'Z'})");
    }
    else
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-disabled=>1);
    }
    print '</td>';
    print "\n";
}
print '</table>';
print p();
if($back)
{
    print button(-name=>'Back',-class=>'s3',-style=>'width:100px;',-onclick=>'history.back()');
}
elsif (param('readonly'))
{
    print button(-name=>'Close',-class=>'s3',-style=>'width:100px;',-onclick=>'window.close()');
}
else
{
    print button(-name=>'Close',-class=>'s3',-style=>'width:100px;',-onclick=>'my_close()');
}
print '</center>';


my @array = ('var ecls = new Array;');
foreach (@list)
{
    push @array,'ecls['.$$_{'Z'}.'] = "'.$$_{'eclass'}.'";';
}
my $str = join("\n",@array);
if ($furnace)
{
    $str .= "\nvar furnace = true\n";
}
else
{
    $str .= "\nvar furnace = false\n";
}

print <<END;


<script>

$str


function my_close()
{
    if (furnace)
    {
	opener.document.set_elements.submit();
    }
    window.close();
}

function set_element(id)
{
    var node = document.getElementById('fld_'+id);
    var btn = document.getElementById('btn_'+id);
    var chk = document.getElementById('chk_'+id);
    if (chk.checked)
    {
	node.setAttribute("class","selected");
	node.setAttribute("className","selected");	
    }
    else
    {
	node.setAttribute("class",ecls[id]);
	node.setAttribute("className",ecls[id]);
    }
    save_elements();
}


function save_elements()
{
    var arr = new Array();
    var x;
    for (x = 1; x < 119; x++)
    {
	var chk = document.getElementById('chk_'+x);
	var btn = document.getElementById('btn_'+x);
	if (chk.checked)
	{
	    arr.push(btn.name);
	}
    }
    var str = arr.join(',');
    if (furnace)
    {
	opener.document.getElementById('f_elements').value = str;
    }
    else
    {
	opener.document.getElementById('comp').value = str;
	opener.element_ok = true;
    }
}


</script>

END
