#!/usr/bin/perl                                                                 
# $Id: show_old.cgi,v 1.9 2017/08/08 11:05:21 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2017              ###
###                                                      ###
############################################################
############################################################
use strict;
use warnings;
use CGI qw(:standard :netscape);
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use RFC::Furnace;
my $f = get_CGI_value_clean('rig');
my $run = get_CGI_value_clean('runnr');
$run = get_CGI_value_clean('testnr') unless ($run);
unless ($f)
{
    $f = get_CGI_value_clean('furnace');
    param(-name=>'rig',-value=>$f);
}
unless ($f)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($f);
my $equipid = $rig->get_cv('main','equipmentid');
$equipid = 0 unless ($equipid);
my $eqadr = get_cv('global','remote_equipment_database');
$eqadr = '' unless ($eqadr);
my $logaddr = get_cv('global','logbook_url');

if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end('../RFCfurnace/manual.pdf');
}
else
{
    $rig = RFC::Furnace->new($rig);
    if (login_ok())
    {
        &print_header("Old furnace run for ".$rig,-onload=>'load_start()');
        print <<END;

<script>

function load_start()
{

}

</script>

END

        print RFC_start_html(-title=>"Main menu for rig ".$rig->name, -style=>{src=>'/RFCfurnace/Furnace.css'});
        top_nav_bar_start;
        if ($logaddr && $equipid)
        {
	    top_nav_bar_button($logaddr,'','','Logbook for furnace '.$rig->name,'s3','rig,'.$rig->name.',1',"id,$equipid,1");
	}
        else
        {
	    top_nav_bar_button('../celltest/logbook.cgi','','','Logbook for furnace '.$rig->name,'s3','rig,'.$rig->name.',1');
	}
        top_no_button;
        top_no_button;
        tab_newrow;
        if (get_CGI_value('action'))
        {
	    top_no_button;
	}
        else
        {
	    &js_back();
	    top_js_return('#006600','white');
	}
        top_no_button;
        top_no_button;
        top_no_button;
        top_nav_bar_button('main.cgi','select_server','','To menu','s4');
        end_top_bar;
        &show_old($run);
        &print_end('../RFCfurnace/manual.pdf');
    }
    else
    {
        &not_auth;
    }
}

sub show_old($)
{
    my $runnr = shift;
    my $htacc = $rig->testdir($runnr).'/.htaccess';
    print '<center>';
    if (-e $htacc)
    {
	print h1("Warning the requested furnace run is subject to access restrictions.");
	print h2('click the link below to access the data (requires password)');
	print "< href='/rig".$f."/furnace_runs/$runnr'> Furnace run $runnr </a>";
	print '</center>';
	return;
    }
    print h2("Information for run $runnr for $rig!");
    print '<table class="furnace_main">',"\n";
    print '<tr><td>',"\n";
    print '<table class="program">';
    print '<tr><th>';
    print 'Program information:</th></tr>';
    print '<tr><td>';
    print textarea(-name=>'info',-id=>'info',class=>'proglog',-rows=>12,-readonly=>1);
    print '</td></tr>';
    print '<tr><th>';
    print 'Program log:</th></tr>';
    print '<tr><td>';
    print textarea(-name=>'log',-id=>'log',class=>'proglog',-rows=>12,-readonly=>1);
    print '</td></tr>';
    print '</table>';
    print '</td><td>',"\n";
    print '<a href="/rig'.$f.'/furnace_runs/'.$runnr.'/data.txt"><img id="profile" src="/RFCfurnace/dummy.png"></img></a>';
    print '</td></tr>',"\n";
    print "</table>\n";
    print '</center>';
    my $user = &get_user();

    print <<END;


<script>

window.onblur = set_inactive;
window.onfocus = set_active;
var ispopup = false;
var is_logged_in = true;
var username = '$user';
var program = new Array;
var totalt = 0;

var runnr = $runnr;
var active = false;


function update_plot()
{
    run_ajax('ajax.cgi','&action=plot_program&runnr='+runnr,set_plot);
}

function set_plot(res)
{
    active = false;
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
        document.getElementById('profile').src = arr[1] +'?' + Math.random();
        var p = document.getElementById('program');
        if (p != null)
        {
            p.value = program.join("\\n");
        }
        document.getElementById('totaltime').innerHTML = 'Current program: Total time '+arr[2]+' hours';
        totalt = parseFloat(arr[2]);
        return true;
    }
    alert(res);
}

function check_status()
{
    raw_ajax('../celltest/ajax.cgi','?action=is_logged_in&name='+username,set_status);
}

function set_status(res)
{
    var reg = /YES/;
    if (!reg.test(res))
    {
        is_logged_in = false;
        document.logout.submit();
    }
}

function set_active()
{
    document.data.isactive.value = '1';
}

/* Ugly hack for IE wrongly triggering window onblur when selecting element inside page..... */

function ie_inactive()
{
    if (bIsMSIE && (active_element != document.activeElement)) {
        active_element = document.activeElement;
    }
    else
    {
        document.data.isactive.value = '0';
    }
}

function set_inactive()
{
    if (navigator.appName == "Microsoft Internet Explorer") {
        active_element = document.activeElement;
        bIsMSIE = true;
        document.onfocusout = ie_inactive;
        return false;
    }
    ie_inactive();
}

/* end IE hack */

function load_log()
{
    if (is_logged_in)
    {
        check_status();
        run_ajax('ajax.cgi','&action=get_proglog&runnr='+runnr,set_log);
    }
}

function load_info()
{
    if (is_logged_in)
    {
	check_status();
	run_ajax('ajax.cgi','&action=get_info&runnr='+runnr,set_info);
    }
}

function set_log(t)
{
    var proglog = document.getElementById('log');
    proglog.value = t;
    proglog.scrollTop = proglog.scrollHeight;
}

function set_info(t)
{
    document.getElementById('info').value = t;
}

load_log();
load_info();
update_plot();

</script>

END

}
